using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

namespace MARSTrans
{
  class Program
  {
    static void Main(string[] args)
    {
      SqlTransaction tx = null;

      using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=pubs;multipleactiveresultsets=true")) // 
      using (SqlCommand cmd1 = new SqlCommand("insert jobs values('cmd1', 10, 10);select * from jobs;insert jobs values('cmd1', 10, 10)", conn))
      using (SqlCommand cmd2 = new SqlCommand("insert jobs values('cmd2', 20, 20);select * from jobs", conn))
      {

        try
        {
          // no API transactions
          conn.Open();

          
          SqlDataReader rdr11 = cmd1.ExecuteReader();
          rdr11.Read();
          SqlDataReader rdr12 = cmd2.ExecuteReader();
          rdr12.Read();
           
           
          
                  

          cmd1.CommandText = "insert jobs values('cmd1', 10, 10);select * from jobs";
          SqlDataReader rdr1 = cmd1.ExecuteReader();

          // but this works, begin and end tran in same batch
          cmd2.CommandText = "begin tran;insert jobs values('bobaaa', 20, 20);select * from bigtable;commit";
          SqlDataReader rdr2 = cmd2.ExecuteReader();

          // lets try to break the tran up into two batches
          //cmd2.CommandText = "begin tran;insert jobs values('cmd2', 20, 20);delete jobs where job_id = 3;select * from jobs";
          //SqlDataReader rdr2 = cmd2.ExecuteReader();
            int i=0;
            while (rdr2.Read())
            {
                i++;
            }
          rdr2.Close();
          cmd2.CommandText = "rollback";
          // commit has no begin transaction, (its already rolled back)
          cmd2.ExecuteNonQuery();

          // not here; already an open datareader
          // but add the Close(), works fine
          rdr1.Close();
          //cmd1.CommandText = "begin tran;insert jobs values('cmd1a', 20, 20);insert jobs values('cmd1a', 20, 20);commit;";
          //cmd1.ExecuteNonQuery();


          
        }
        catch (Exception e)
        {
          Console.WriteLine(e.Message);
          if (tx != null) tx.Rollback();
        }

        /* Try 1 - this doesn't work
        try
        {
          conn.Open();

          SqlDataReader rdr1 = cmd1.ExecuteReader();
          // new transactions are not allowed because there are other threads in the session
          tx = conn.BeginTransaction();
          cmd1.Transaction = tx;
          cmd2.Transaction = tx;
          cmd2.ExecuteNonQuery();
          //SqlDataReader rdr2 = cmd2.ExecuteReader();
          //rdr2.Close();
          rdr1.Close();
          tx.Commit();
        }
        catch (Exception e)
        {
          Console.WriteLine(e.Message);
          if (tx != null) tx.Rollback();
        }
        */


        /* Try number 2 - this rolls back because there are pending results
        try
        {
          conn.Open();
          tx = conn.BeginTransaction();
          cmd1.Transaction = tx;
          cmd2.Transaction = tx;
          SqlDataReader rdr1 = cmd1.ExecuteReader();
          
          cmd2.ExecuteNonQuery();
          //SqlDataReader rdr2 = cmd2.ExecuteReader();
          //rdr2.Close();
          rdr1.Close();
          tx.Commit();
        }
        catch (Exception e)
        {
          Console.WriteLine(e.Message);
          if (tx != null) tx.Rollback();
        }
        */
      }
    }
  }
}
